;;
;; GgrTF::RegPouch - Reagent pouch management and liting
;; (C) Copyright 2008 Matti Hmlinen (Ggr)
;;
;; This file (triggerset) is Free Software distributed under
;; GNU General Public License version 2.
;;
;; NOTICE! This file requires GgrTF (version 0.6.3 or later) to be loaded.
;;
/loaded GgrTF::RegPouch
/set gmodule=RegPouch

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WARNING! This code is "beta"-quality, and may contain more problems
;; than rest of GgrTF code... also notice that only 'power' reagents
;; are handled currently...
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Bindings and settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/prdeftoggle -n"reglite"	-d"Lite/prettify reagent pouch"
/set opt_reglite=on

/prdefgbind -s"rpouch"	-c"/rpouch"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Helper for reagent pouch
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/set rpouch_get=0
/set rpouch_regs=

/def -i grpouch_report =\
	/if (regmatch("^[0-9]+$",{1}))\
		/let _nval=%{1}%;\
	/elseif ({1}=~"One")	/let _nval=1%;\
	/elseif ({1}=~"Two")	/let _nval=2%;\
	/elseif ({1}=~"Three")	/let _nval=3%;\
	/elseif ({1}=~"Four")	/let _nval=4%;\
	/elseif ({1}=~"Five")	/let _nval=5%;\
	/elseif ({1}=~"Six")	/let _nval=6%;\
	/elseif ({1}=~"Seven")	/let _nval=7%;\
	/elseif ({1}=~"Eight")	/let _nval=8%;\
	/elseif ({1}=~"Nine")	/let _nval=9%;\
	/else /gerror Invalid value in '%{1}' in grpouch_report(%{*})%;/break%;/endif%;\
	/if (rpouch_get)\
		/set rpouch_%{rpouch_name}_%{7}=%{2}%;\
		/substitute -ag%;\
	/else \
		/if (opt_reglite=~"on")\
			/substitute -p @{BCyellow}$[pad(_nval,5)]@{n} | @{BCgreen}$[pad({6},-25)]@{n} (@{BCred}$[pad({2},4)]@{n},@{Cgreen}$[pad({3},4)]@{n},@{Cyellow}$[pad({4},4)]@{n}) @{BCgray}($[prsubstr({5},columns()-55)])@{n}%;\
		/endif%;\
	/endif

/def -i -Erpouch_get==1 -p9999 -mregexp -t"^(This is a large pouch for the storing of reagents|reagents over reboots in this.|Syntax: store <item> in <this>| +extract .amount. <item>| +set_default_reagent|transfer .number. .reagent.|Some commands allow the use of|It is labeled as |The label can be set with |[Ii]t is surrounded by )" grpouch_gag =\
	/substitute -ag

/def -i -p9999 -F -msimple -t"The pouch contains:" grpouch_start =\
	/set rpouch_st=1%;\
	/if (rpouch_get) /substitute -ag%;/endif

/def -i -Erpouch_get==1 -p9999 -F -msimple -t"You see nothing special." grpouch_end2 =\
	/substitute -ag%;\
	/set rpouch_st=0%;\
	/set rpouch_get=0%;\
	/msq @{BCred}No such reagent pouch@{n} '@{BCgreen}%{rpouch_target}@{n}'!

/def -i -Erpouch_st==1 -p9999 -F -mregexp -t"^This item is in " grpouch_end =\
	/set rpouch_st=0%;\
	/if (rpouch_get) /substitute -ag%;/eval /repeat -1 1 /%{rpouch_dest}%;/endif


;; Define reagents and mangler macros
/def -i gdefrpouch =\
	/let _tmps=$[replace(" ","_",tolower({3}))]%;\
	/set rpouch_regs=%{rpouch_regs} %{_tmps}%;\
	/set rpouch_reg_%{_tmps}=%{2}%;\
	/prdefivar rpouch_set_%{_tmps} 0%;\
	/def -i -p9999 -Erpouch_st==1 -mregexp -t"^(One|Two|Three|Four|Five|Six|Seven|Eight|Nine|[0-9]+) (%{1}) \\(([0-9]+) power, ([0-9]+) standard, ([0-9]+) poor\\)$$" grpouch_%{_tmps} =\
		/test grpouch_report({P1},{P3},{P4},{P5},{P2},"%{3}","%{_tmps}")


/test gdefrpouch("handfuls? of olivine powder",	"Olivine powder",	"Acid Blast")
/test gdefrpouch("stone cubes?",		"Stone cube",		"Acid Shield")
/test gdefrpouch("pairs? of interlocked bloodstone rings","Interlocked rings",	"Acid Storm")
/test gdefrpouch("small highsteel discs?",	"Highsteel disc",	"Armour of Aether")
/test gdefrpouch("tiny leather bags? \(empty\)","Leather bag",		"Aura of Wind")
/test gdefrpouch("bronze marbles?",		"Bronze marble",	"Blast Vacuum")
/test gdefrpouch("steel arrowheads?",		"Steel arrowhead",	"Cold Ray")
/test gdefrpouch("small pieces? of electrum wire","Electrum wire",	"Electrocution")
/test gdefrpouch("small glass cones?",		"Glass cone",		"Flame Shield")
/test gdefrpouch("grey fur triangles?",		"Fur triangle",		"Frost Shield")
/test gdefrpouch("copper rods?",		"Copper rod",		"Golden Arrow")
/test gdefrpouch("handfuls? of onyx gravel",	"Onyx gravel",		"Hailstorm")
/test gdefrpouch("ebony tubes?",		"Ebony tube",		"Killing Cloud")
/test gdefrpouch("granite spheres?",		"Granite sphere",	"Lava Blast")
/test gdefrpouch("blue cobalt cups? \(empty\)",	"Cobalt cup",		"Lava Storm")
/test gdefrpouch("small iron rods?",		"Iron rod",		"Lightning Shield")
/test gdefrpouch("clusters? of tungsten wires",	"Tungsten wire",	"Lightning Storm")
/test gdefrpouch("tiny platinum hammers?",	"Platinum hammer",	"Magic Eruption")
/test gdefrpouch("quartz prisms?",		"Quartz prism",		"Repulsor Aura")
/test gdefrpouch("tiny amethyst crystals?",	"Amethyst crystal",	"Shield of Detoxification")
/test gdefrpouch("silvery bark chips?",		"Bark chip",		"Summon Carnal Spores")
/test gdefrpouch("small brass fans?",		"Small brass fan",	"Vacuum Globe")


/def -i grpouch_list =\
	/msw ,---------------,%;\
	/msw | @{BCgreen}GgrTF@{n} @{Cyellow}RP List@{n} |%;\
	/msw +---------------+----------------------------------+--------.%;\
	/msw | @{BCgreen}Spell name@{n}                | @{BCyellow}Reagent@{n}              |  @{BCwhite}Stock@{n} |%;\
	/msw +---------------------------+----------------------+--------+%;\
	/let _rp_total=0%;\
	/while ({#})\
		/eval /set _rp_name=$$[rpouch_reg_%{1}]%;\
		/eval /set _rp_num=$$[rpouch_set_%{1}]%;\
		/let _rp_rname=$[replace("_"," ",{1})]%;\
		/let _rp_total=$[_rp_total + _rp_num]%;\
		/msw | @{Cgreen}$[pad(_rp_rname,-25)]@{n} | @{Cyellow}$[pad(_rp_name,-20)]@{n} | $[pad(_rp_num,6)] |%;\
		/shift%;\
	/done%;\
	/msw +--------------------------------------------------+--------+%;\
	/msw | Total reagents to be stocked ................... | @{BCgreen}$[pad(_rp_total,6)]@{n} |%;\
	/msw `--------------------------------------------------+--------'


/def -i grpouch_adjust =\
	/let _rval=%{1}%;/shift%;\
	/let _rnum=0%;\
	/while ({#})\
		/eval /set _rp_nset=$$[rpouch_set_%{1}]%;\
		/if (_rp_nset > 0)\
			/set rpouch_set_%{1}=%{_rval}%;\
			/let _rnum=$[_rnum+1]%;\
		/endif%;\
		/shift%;\
	/done%;\
	/msq Adjusted @{BCgreen}%{_rnum}@{n} set pouch reagents to @{BCwhite}%{_rval}@{n}%;\


/def -i grpouch_clear =\
	/let _rval=%{1}%;/shift%;\
	/while ({#})\
		/set rpouch_%{_rval}_%{1}=0%;\
		/shift%;\
	/done


/def -i grpouch_set_all =\
	/let _rval=%{1}%;/shift%;\
	/msq Setting all reagents to %{_rval}%;\
	/while ({#})\
		/eval /set _rp_nset=$$[rpouch_set_%{1}]%;\
		/set rpouch_set_%{1}=%{_rval}%;\
		/shift%;\
	/done


;; Contents of "from" pouch got, now get contents of "to" pouch
/def -i grpouch_fill1 =\
	/set rpouch_dest=grpouch_fill2%;\
	/set rpouch_name=to%;\
	/set rpouch_target=%{rpouch_to}%;\
	@@look at %{rpouch_to}


;; We now have contents of both pouches .. start moving.
/def -i grpouch_fill2 =\
	/set rpouch_get=0%;\
	/set rpouch_dest=%;\
	/grpouch_move %{rpouch_regs}
	
/def -i grpouch_move =\
	/if (rpouch_mode=~"check")\
	/msw ,-----------------------------.                                    ,---------.%;\
	/msw | Would transfer following... |                                    |   Buy   |%;\
	/msw +----------------------+-------------------------------------------+---------+%;\
	/else \
	/msq Moving reagents ...%;\
	/endif%;\
	/let _rnum=0%;\
	/while ({#})\
		/eval /set _rp_name=$$[rpouch_reg_%{1}]%;\
		/eval /set _rp_nfrom=$$[rpouch_from_%{1}]%;\
		/eval /set _rp_nto=$$[rpouch_to_%{1}]%;\
		/eval /set _rp_nset=$$[rpouch_set_%{1}]%;\
		/if (_rp_nset > 0)\
		/let _rtmp=$[_rp_nset - _rp_nto]%;\
		/if (_rtmp > 0)\
			/let _vbuy=$[_rp_nfrom - _rtmp]%;\
			/if (_rtmp > _rp_nfrom)\
				/let _vmove=%{_rp_nfrom}%;\
				/let _vcol=BCred%;\
				/let _vstr=Has %{_rp_nto}, wants %{_rp_nset} (%{_rp_nfrom} in store)%;\
			/else \
				/let _vmove=%{_rtmp}%;\
				/let _vcol=BCgreen%;\
				/let _vstr=Moving %{_rtmp} of %{_rp_nfrom} to %{_rp_nto}%;\
			/endif%;\
			/if (rpouch_mode=~"check")\
			/msw | @{Cyellow}$[pad(_rp_name,-20)]@{n} | @{%{_vcol}}$[pad(_vstr,-41)]@{n} | @{%{_vcol}}$[pad(_vbuy,7)]@{n} |%;\
			/else \
			/if (_vmove > 0)\
			/set _rp_name=$[tolower(_rp_name)]%;\
			/msq Transferring %{_vmove} x '%{_rp_name}' (wanted %{_rtmp})%;\
			@@transfer %{_vmove} %{_rp_name} from %{rpouch_from} to %{rpouch_to} take power%;\
			/endif%;\
			/endif%;\
			/let _rnum=$[_rnum+1]%;\
		/endif%;\
		/endif%;\
		/shift%;\
	/done%;\
	/if (rpouch_mode=~"check")\
	/msw +-------------------+--+-------------------------------------------+---------'%;\
	/msw | @{BCwhite}$[pad(_rnum,5)]@{n} types total |%;\
	/msw `-------------------'%;\
	/else \
	/msq Done.%;\
	/endif


;; Main command interface
/def -i rpouch =\
	/let _args=$[tolower({*})]%;\
	/if (regmatch("^(fill|check) +([A-Za-z0-9_-]+) +from +([A-Za-z0-9_][A-Za-z0-9_ -]+)$", _args))\
		/set rpouch_mode=%{P1}%;\
		/set rpouch_to=%{P2}%;\
		/set rpouch_from=%{P3}%;\
		/if (rpouch_mode=~"fill")\
			/msq @{BCwhite}Moving reagents from@{n} '@{BCgreen}%{rpouch_from}@{n}' @{BCwhite}to@{n} '@{BCred}%{rpouch_to}@{n}'%;\
		/else \
			/msq @{BCwhite}Checking reagents in@{n} '@{BCgreen}%{rpouch_from}@{n}' @{BCwhite}<->@{n} '@{BCred}%{rpouch_to}@{n}'%;\
		/endif%;\
		/msq Getting pouch contents, please wait...%;\
		/grpouch_clear to %{rpouch_regs}%;\
		/grpouch_clear from %{rpouch_regs}%;\
		/set rpouch_get=1%;\
		/set rpouch_dest=grpouch_fill1%;\
		/set rpouch_name=from%;\
		/set rpouch_target=%{rpouch_from}%;\
		@@look at %{rpouch_from}%;\
	/elseif (regmatch("^(rset|set) +([A-Za-z][A-Za-z ]+) to ([0-9]+)$", _args))\
		/if ({P1}=~"set")\
			/let _tmps=$[replace(" ","_",tolower({P2}))]%;\
			/eval /set _rpas=$$[rpouch_reg_%{_tmps}]%;\
			/if (_rpas!~"")\
				/msq Reagent '@{Cgreen}%{_tmps}@{n}' (@{Cyellow}%{_rpas}@{n}) set to @{BCwhite}%{P3}@{n}%;\
				/set rpouch_set_%{_tmps}=%{P3}%;\
			/else \
				/msq @{BCred}No such spell@{n} '@{BCwhite}%{P2}@{n}'!%;\
			/endif%;\
		/else \
			/gerror This setting does not work yet!%;\
		/endif%;\
	/elseif (regmatch("^adjust +([0-9]+)$", _args))\
		/grpouch_adjust %{P1} %{rpouch_regs}%;\
	/elseif (regmatch("^all +([0-9]+)$", _args))\
		/grpouch_set_all %{P1} %{rpouch_regs}%;\
	/elseif (_args=~"list")\
		/grpouch_list %{rpouch_regs}%;\
	/else \
		/msq @{BCgreen}GgrTF@{n} - @{Cyellow}Reagent Pouch Manager@{n}%;\
		/msq -----------------------------%;\
		/msq /rpouch @{BCwhite}(fill|check)@{n} @{Cgreen}<to pouch>@{n} @{BCwhite}from@{n} @{Cred}<from pouch>@{n} [@{BCwhite}in@{n} @{Cyellow}<container>@{n}]%;\
		/msq /rpouch @{BCwhite}set@{n} @{Cgreen}<spell>@{n} @{BCwhite}to@{n} <amount>%;\
		/msq /rpouch @{BCwhite}rset@{n} @{Cgreen}<reagent>@{n} @{BCwhite}to@{n} <amount>%;\
		/msq /rpouch @{BCwhite}adjust@{n} @{Cgreen}<amount>@{n}%;\
		/msq /rpouch @{BCwhite}all@{n} @{Cgreen}<amount>@{n}%;\
		/msq /rpouch @{BCwhite}list@{n}%;\
	/endif
